"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStore = void 0;
var redux_thunk_1 = __importDefault(require("redux-thunk"));
var redux_1 = require("redux");
var extension_1 = require("@redux-devtools/extension");
var generateReducer_1 = require("./utils/generateReducer");
var createStore = function (reducers, options) {
    var enableDevtools = "enableDevtools" in options ? options.enableDevtools : false;
    // format reducer
    var rootReducer = (0, redux_1.combineReducers)(reducers.reduce(function (result, current) {
        var _a;
        return __assign(__assign({}, result), (Object.keys(current.reducers).length > 0 && (_a = {},
            _a[current.combineName] = (0, redux_1.combineReducers)(__assign({}, (0, generateReducer_1.generateReducer)(current.reducers, current.combineName))),
            _a)));
    }, {}));
    return (0, redux_1.createStore)(rootReducer, enableDevtools ? (0, extension_1.composeWithDevTools)((0, redux_1.applyMiddleware)(redux_thunk_1.default)) : (0, redux_1.compose)((0, redux_1.applyMiddleware)(redux_thunk_1.default)));
};
exports.createStore = createStore;
